<%@ LANGUAGE="VBSCRIPT" %>

<html>
<HEAD>
<title>Credit Account Information using the Internet</title>
</HEAD>
<body>
<%
        ' Sample logon to CICS using Active Server Pages
        ' 1 September 1998
        ' Author: Jim MacNair, IBM Corp
        ' On Error Resume Next

        ' The following sequence will leave the terminal
        ' session on a blank screen.  This script uses the
        ' signon program which is provided with this
        ' SupportPac.

        ' variable definitions
        Dim strUser
        Dim strPW
        Dim strSystem
        Dim strNetName
        Dim strModTerm
        Dim strErrmsg
        dim strCICSErrmsg
        dim strSignon
        dim intEventype
        dim strScreenImage
        Dim intRC
        dim intWorked
        dim objterm3270
        dim strFilename

        intWorked = 0
        intEventype = 0

        ' get a pointer to the 3270 terminal object
        set objterm3270 = Session("objterm3270")

        strFilename = Session("strTracefile")
        if strFilename = "" then
            ' create a unique trace file name in the c:\temp directory
            strFilename = "c:\temp\epi" & Session.SessionID & ".trc"
            ' Start the trace with the append option
            intRC = objterm3270.SetTrace(2,CStr(strFilename))
            Session("strTracefile") = strFilename
        end if

        ' get the userid, password, system name, etc. from the form
        strUser = Request.Form("CICSUSER")
        strPW =   Request.Form("CICSPW")
        strSystem = Request.Form("CICSSYS")
        strNetName = Request.Form("CICSNETNAME")
        strModTerm = Request.Form("CICSMODTERM")

        ' check if we have installed a terminal in CICS
        if session("strTermName") = "" then
            intRC = objterm3270.CreateTerminal(strSystem, strNetName, strModTerm)

            if intRC = 0 then
                ' Set a session level variable to remember the terminal name
                Session("strTermName") = objterm3270.termname
            else
                strCICSErrmsg = objterm3270.EPIErrorMessage(intRC)
                strErrmsg = "Unable to Install CICS Terminal - Return Code " + CStr(intRC)
            end if
        else
            intRC = 0   ' Set the return code
	        Session("strTermName") = objterm3270.termname
        end if

        if intRC = 0 then
            ' clear the screen
			Clear3270Screen

            ' build the signon string
            strSignon = "SGON " & strUser & " " & strPW

            ' type the data into the screen image
            intRC = objterm3270.keyin(strSignon)

            ' Run the line mode sign on transaction (SGON)
            intRC = objterm3270.BeginTran("SGON","ENTER")

            ' check if the transaction was started 
            if intRC = 0 then
                ' Wait for the Transaction to complete
                intRC = objterm3270.WaitEvent(intEventype)
                ' Get the type of event
                ' intEventype = objterm3270.lastevent
            else
                ' create error message
                strCICSErrmsg = objterm3270.EPIErrorMessage(intRC)
                strErrmsg = "Error running Sign on (SGON) transaction - " + CStr(intRC)
            end if
        end if

        if intRC = 0 then
            ' Get the screen image as a string
            strScreenImage = objterm3270.GetScreenImage("","")
			' Check for signed on or already signed on error
            if left(strScreenImage,5) = "00000" or left(strScreenImage,5) = "00016" then
                intWorked = 1
            else
                strCICSErrmsg = mid(strScreenImage, 12, 80)
                strErrmsg = "CICS Sign On Failed - RESP code is " + left(strScreenImage,11)
            end if

            ' clear the screen
            objterm3270.clearScreen

            ' check if a transaction was started
            if objterm3270.transid <> "" then
                intRC = objterm3270.WaitEvent(intEventype)
                intEventype = objterm3270.lastevent
            end if
        end if

        ' Check if the Logon worked
        if intWorked = 1 Then
                ' Store the data in the Session object
                Session.Value("CICSUser")     = strUser
                Session.Value("CICSPW")       = strPW
                Session.Value("CICSSystem")   = strSystem
                Session.Value("CICSNetName")  = strNetName

                ' Start writing the HTML page
%>
<h1>Credit Account Information</h1>
You can obtain detailed information about your credit account, and if
you wish, change your address using the <b>Internet</b><p>
<form action="/aspepi/credepi.asp" method ="POST"><p>
Type your account number (6 digits):
<input name="ACCTNO" value="" size=6 maxlength=6><p>
<hr>
<h2>To add a record, fill in the following fields</h2><p>
Name:
<input name="NAME" value="" size=23 maxlength=20>
Address:
<input name="ADDRESS" value="" size=23 maxlength=20><p>
Phone:
<input name="PHONE" value="" size=8 maxlength=8>
Date:
<input name="DATE" value="" size=8 maxlength=8><p>
Amount($xxxx.xx):
<input name="AMOUNT" value="" size=8 maxlength=8>
Comment:
<input name="COMMENT" value="" size=10 maxlength=9><p>
<hr>
<input type="submit" name="SUBMIT" value="Show Details">
<input type="submit" name="SUBMIT" value="Browse Accounts">
<input type="submit" name="SUBMIT" value="Add New Account">
<input type="submit" name="SUBMIT" value="Clear Form">
<input type="submit" name="SUBMIT" value="Logoff"><p>
<%
        ' We had an error  - send the error message back to the user
        Else
            ' Write a trace record, if trace is on
            objterm3270.WriteTraceLine("Error signing on - Deleting the terminal",0)

            ' release the terminal
            intRC = objTerm3270.DeleteTerminal

            ' Check if the delete terminal worked
            If intRC = 0 Then
                objterm3270.WriteTraceLine("Terminal Deleted OK",0)
            Else
                objterm3270.WriteTraceLine("Error Deleting Terminal",0)
            End if

            ' remember to reinstall the terminal next time through
            session("strTermName") = ""
%>
<h1>CICS LOGON</h1>
Please enter your userid and password<p>
<form action="/aspepi/epilogon.asp" method ="POST"><p>
CICS Userid:
<input name="CICSUSER" value="<% = strUser %>" size=8 maxlength=8>
CICS Password:
<input name="CICSPW" value="<% = strPW %>" size=8 maxlength=8 type=password><p>
CICS System:
<input name="CICSSYS" value="<% = strSystem %>" size=8 maxlength=8>
<p>
Network Name:
<input name="CICSNETNAME" value="<% = strNetName %>" size=8 maxlength=8>
Model Terminal:
<input name="CICSMODTERM" value="<% = strModTerm %>" size=8 maxlength=8>
<p>
<input type="submit" name="SUBMIT" value="Logon to CICS"><p>
<HR>
*** Error Logging on to CICS ***<P>
<% = strErrmsg %>
*** CICS error was <% = strCICSErrmsg %> ***
<HR>
<%
        End If
%>
</form>
</body></html>
<%
    Sub Clear3270Screen
        ' This routine attempts to clear the 3270 screen to an unformatted state
        dim intClearcnt
		Dim intEventype

		' Initilize the variables
		intEventype = 0
        intClearcnt = 0
        Do Until intClearcnt > 2 or objTerm3270.numberFields = 0
            objterm3270.ClearScreen
            intClearcnt = intClearcnt + 1

			' Check if we started a transaction or are still in one
			if objterm3270.transid <> "" Then
				' If so, wait for an event
				objterm3270.WaitEvent(intEventype)
			End if
        Loop
    End Sub
%>