#if !defined(AFX_API3270_H__AFCB2CB5_1A98_11D2_BC8F_204C4F4F5020__INCLUDED_)
#define AFX_API3270_H__AFCB2CB5_1A98_11D2_BC8F_204C4F4F5020__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// api3270.h : header file
//

// CICS Client EPI Support
#define u_short_t cics_ushort_t
#define u_byte_t  cics_ubyte_t
#include "c3270.h"
#include <cics_epi.h>

#define MAX_SAVED_EVENTS 100
#define MAX_CICS_SYSTEMS 25	// Maximum number of CICS systems defined for client

/////////////////////////////////////////////////////////////////////////////
// api3270 command target

class api3270 : public CCmdTarget
{
	DECLARE_DYNCREATE(api3270)

	api3270();           // protected constructor used by dynamic creation

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(api3270)
	public:
	virtual void OnFinalRelease();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~api3270();

	// Generated message map functions
	//{{AFX_MSG(api3270)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	DECLARE_OLECREATE(api3270)

	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(api3270)
	CString m_nextransid;
	short m_numberFields;
	CString m_transid;
	short m_numberUnprotFields;
	short m_rows;
	short m_columns;
	CString m_termname;
	short m_lastevent;
	long m_tranCount;
	long m_endTranCount;
	long m_atiCount;
	long m_convCount;
	long m_sendCount;
	long m_lastResponse;
	long m_bytesSent;
	long m_bytesReceived;
	long m_readBufferCount;
	long m_totalResponses;
	long m_totalResponseTime;
	afx_msg short BeginTran(LPCTSTR transid, LPCTSTR AIDType);
	afx_msg short SendInput(LPCTSTR AIDByte);
	afx_msg short WaitATI(VARIANT FAR* eventType);
	afx_msg short ModifyField(short row, short col, LPCTSTR fieldData);
	afx_msg short ModifyFieldNum(short fieldNum, LPCTSTR fieldData);
	afx_msg short SetCursor(short row, short col);
	afx_msg void ClearScreen();
	afx_msg short GetFieldData(short row, short col, VARIANT FAR* fieldData);
	afx_msg short GetFieldDataNum(short fieldNum, VARIANT FAR* fieldData);
	afx_msg short GetFieldAttribute(short row, short col, VARIANT FAR* attr, VARIANT FAR* extattr, VARIANT FAR* color);
	afx_msg short GetFieldRowCol(short fieldNum, VARIANT FAR* row, VARIANT FAR* col);
	afx_msg short GetFieldLength(short row, short col, VARIANT FAR* length);
	afx_msg short keyin(LPCTSTR keyData);
	afx_msg short CreateTerminal(LPCTSTR regionName, LPCTSTR netName, LPCTSTR devType);
	afx_msg short WaitEvent(VARIANT FAR* eventType);
	afx_msg short CheckEvent(VARIANT FAR* eventType);
	afx_msg short GetScreenSum();
	afx_msg BSTR EPIErrorMessage(short rc);
	afx_msg short GetDataAtLoc(short row, short col, short numchars, VARIANT FAR* data);
	afx_msg short DeleteTerminal();
	afx_msg short SetTrace(short reqtype, LPCTSTR tracefile);
	afx_msg void DumpFields();
	afx_msg void WriteFields();
	afx_msg void WriteTraceLine(LPCTSTR traceline, short tracelevel);
	afx_msg void TraceScreen(LPCTSTR protchar, LPCTSTR unprotchar);
	afx_msg short GetCursorLoc();
	afx_msg short CheckATI(VARIANT FAR* eventType);
	afx_msg BSTR GetScreenImage(LPCTSTR protchar, LPCTSTR unprotchar);
	afx_msg BSTR GetFields();
	afx_msg BSTR GetProtTable();
	afx_msg BSTR GetEventTrace();
	afx_msg BSTR GetDataByNum(short fieldNum);
	afx_msg short ServerCount();
	afx_msg BSTR ServerName(short serverNumber);
	afx_msg void SetTraceLevel(short tracelevel);
	afx_msg short GetUnprotFieldRowCol(short fieldNum, VARIANT FAR* row, VARIANT FAR* col);
	afx_msg short ModifyUnprotFieldNum(short fieldNum, LPCTSTR fieldData);
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()

private:
	/////////////////////////////
	// Terminal index used by EPI
	/////////////////////////////
	u_short_t    TermIndex;

	// Timing work variables
	LARGE_INTEGER	timestart;
	int		prevTime;
	void calcLastResponse();

	// Declare a 3270 Screen Buffer Object
	C3270*	screen;
	char	lastEvents[MAX_SAVED_EVENTS];
	char    lastEventData[4 * MAX_SAVED_EVENTS];
	int		lastEventTime[MAX_SAVED_EVENTS];
	int processAID(char *cmdData);
	short modifybynum(short fieldNum, LPCTSTR fieldData, int fldtype, int numflds);
	void HandleOutbound(u_byte_t *data, int length);
	int waitForEvent(cics_ushort_t * eventType, CICS_EpiWait_t waitType);
	short waitForATI(CICS_EpiWait_t waitType, cics_ushort_t *eventType, char* modname);
	char parseAid(LPCTSTR aidstr);
	void eventmsg(short eventType, char* msg);
	void saveLastResponse();
	void InitializeTerminal();
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_API3270_H__AFCB2CB5_1A98_11D2_BC8F_204C4F4F5020__INCLUDED_)

/////////////////
// End Of File //
/////////////////
