VERSION 5.00
Begin VB.Form login 
   Caption         =   "CICS Logon"
   ClientHeight    =   4305
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5295
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   ScaleHeight     =   4305
   ScaleWidth      =   5295
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox cics_regions 
      Height          =   450
      ItemData        =   "login.frx":0000
      Left            =   1800
      List            =   "login.frx":0002
      TabIndex        =   12
      ToolTipText     =   "CICS Region to connect to"
      Top             =   1080
      Width           =   1095
   End
   Begin VB.TextBox ModelTerm 
      Height          =   285
      Left            =   1800
      MaxLength       =   16
      TabIndex        =   10
      ToolTipText     =   "Name of CICS Model Terminal to use (Optional)"
      Top             =   2040
      Width           =   1695
   End
   Begin VB.CommandButton Cancel 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   3000
      TabIndex        =   5
      ToolTipText     =   "Exit from the applicaition"
      Top             =   3360
      Width           =   1215
   End
   Begin VB.CommandButton Logon 
      Caption         =   "Logon to CICS"
      Default         =   -1  'True
      Height          =   495
      Left            =   840
      TabIndex        =   4
      ToolTipText     =   "Validate the user id and password"
      Top             =   3360
      Width           =   1215
   End
   Begin VB.TextBox cics_error_msg 
      Height          =   285
      Left            =   480
      TabIndex        =   9
      TabStop         =   0   'False
      ToolTipText     =   "Error messages"
      Top             =   2760
      Width           =   4215
   End
   Begin VB.TextBox network_name 
      Height          =   285
      Left            =   1800
      MaxLength       =   8
      TabIndex        =   3
      ToolTipText     =   "CICS client name (max 4 chars)"
      Top             =   1680
      Width           =   855
   End
   Begin VB.TextBox cics_pw 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   1800
      MaxLength       =   8
      PasswordChar    =   "*"
      TabIndex        =   2
      ToolTipText     =   "Enter CICS password (max 8 chars)"
      Top             =   720
      Width           =   855
   End
   Begin VB.TextBox cics_user 
      Height          =   285
      Left            =   1800
      MaxLength       =   8
      TabIndex        =   1
      ToolTipText     =   "Enter CICS user id (max 8 chars)"
      Top             =   360
      Width           =   855
   End
   Begin VB.Label Label5 
      Caption         =   "Model Terminal"
      Height          =   255
      Left            =   360
      TabIndex        =   11
      Top             =   2040
      Width           =   1095
   End
   Begin VB.Label Label4 
      Caption         =   "Network Name"
      Height          =   255
      Left            =   360
      TabIndex        =   8
      Top             =   1680
      Width           =   1095
   End
   Begin VB.Label Label3 
      Caption         =   "CICS System"
      Height          =   255
      Left            =   360
      TabIndex        =   7
      Top             =   1200
      Width           =   975
   End
   Begin VB.Label Label2 
      Caption         =   "Password"
      Height          =   255
      Left            =   360
      TabIndex        =   6
      Top             =   735
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "User ID"
      Height          =   255
      Left            =   360
      TabIndex        =   0
      Top             =   375
      Width           =   615
   End
End
Attribute VB_Name = "login"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public EPI As CclEPI
Public terminal As CclTerminal
Public Session As CclSession
Dim screen As CclScreen

Public ca_user As String
Public ca_system As String

' Sign on transaction field characteristics
Const CESNFLDS = 20
Dim CESNUSER As Integer
Dim CESNPW As Integer

    Dim terminst As String

Private Sub Cancel_Click()
 Unload Me
End Sub

Private Sub Form_load()
    ' Working variables
    Dim i As Integer
    Dim j As Integer
    Dim ServName As String
 
    ' Initialize the CESN field variables
    CESNUSER = 0
    CESNPW = 0
        
    getcontrols login
 
    ' Make sure we do not start with a terminal object
    Set terminal = Nothing
    
    ' Create the other objects
    Set EPI = CreateObject("Ccl.EPI")
    Set Session = CreateObject("Ccl.Session")
    Session.SetSyncType (cclSync)

    ' Get the list of CICS servers from the client and add them to the listbox
    i = 0
    j = EPI.ServerCount
    While i < j
        ' Get the server name
        ServName = EPI.ServerName(i + 1)

        ' Add it to the list box
        cics_regions.AddItem (ServName)
   
        ' move on to the next defined server
        i = i + 1
    Wend
    
    ' set the default server selection
    cics_regions.ListIndex = 0
    
    ' Load the debugging form and display it
    Load Debugfrm
    Debugfrm.Visible = True
End Sub


Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    ' delete the EPI objects we created
    Set Session = Nothing
    Set EPI = Nothing
    If Not (terminal Is Nothing) Then
        On Error Resume Next
        terminal.Disconnect
        Set terminal = Nothing
    End If
    
    ' end the program
    End
End Sub

Private Sub Logon_Click()
    Dim tran As String
    Dim nxtran As String
    Dim error_msg As String
    Dim screendata As Variant
    Dim s As String
 
    terminst = ""
    ' Get the selected CICS region
    If cics_regions.ListIndex = -1 Then
        ' use the default system if no selection
        ca_system = EPI.ServerName(1)
    Else
        ' use the selected system
        ca_system = EPI.ServerName(cics_regions.ListIndex + 1)
    End If
    
    ' Check if we already have a terminal - if we do, we are going to release
    ' it, in case the user has changed one of the input fields
    If Not (terminal Is Nothing) Then
        terminal.Disconnect
        Set terminal = Nothing
    End If
    
    ' create a terminal for the selected region
    Set terminal = CreateObject("Ccl.Terminal")
    
    terminal.Connect ca_system, ModelTerm.Text, network_name.Text
    'terminal.Connect cics_system.Text, ModelTerm.Text, network_name.Text
    
    ' were we able to install the terminal?
    If terminal.ExCode = cclNoError Then
        ' remember what system we are connected to
        terminst = terminal.NetName
    Else
        ' issue error message and return to user
        cics_error_msg.Text = "Cannot create terminal - return code " + Str$(terminal.ExCode)
        Exit Sub
    End If
            
    If terminst <> "" Then
        ' try to run the CICS sign on (CESN) transaction
        rc = run_signon
        ' check that the sign on worked
        If rc = 0 Then
            ' Save the CICS userid
            ca_user = cics_user.Text
        
            ' load the detail form
            Load detfrm
            
            ' Move on to the detail form
            detfrm.Show
        End If
    End If
    
End Sub

Private Function run_signon() As Long
    Dim fld As CclField
    Dim intFlds As Integer
    Dim i As Integer
    Dim j As Integer
    Dim lngrc As Long
    Dim lngrc2 As Long
    Dim strTran As String
    Dim strsrch As String
    Dim strFld As String
    Dim rc As Integer
    
    ' Initialize variables
    rc = 0
    
    ' get a pointer to the screen object
    Set screen = terminal.screen
    
    ' Create the field object
    Set fld = CreateObject("ccl.Field")
    
    ' update the debug form
    Debugfrm.update_data terminal
    
    ' clear the screen
    screen.SetAID cclClear
    terminal.Send Session
    
    ' update the debug form
    Debugfrm.update_data terminal
    
    ' start a CESN transaction to format the screen
    screen.SetAID cclEnter
    terminal.Start Session, "CESN", ""
            
    ' update the debug form
    Debugfrm.update_data terminal
    
    ' Check how many fields are on the screen
    intFlds = screen.FieldCount
    strTran = terminal.transid
    
    ' did it work?
    If intFlds > 0 Then
        ' check if we have already found the user id and password fields
        If CESNPW = 0 Then
            findfields
        End If
        
        ' set the user id
        Set fld = screen.FieldByIndex(CESNUSER)
        fld.SetText cics_user.Text
        
        ' set the password
        Set fld = terminal.screen.FieldByIndex(CESNPW)
        fld.SetText cics_pw.Text
        
        ' update the debug form
        Debugfrm.update_data terminal
    
        ' set the aid key
        screen.SetAID cclEnter
        
        ' run the sign on transaction
        terminal.Start Session, "CESN", ""
        
        ' update the debug form
        Debugfrm.update_data terminal
    
        ' check if it worked
        ' We attempt to see if the number of fields has changed, and if it
        ' has, we scan the first field for the string "success"
        If screen.FieldCount = intFlds Then
            ' It doesn't appear to have worked
            ' clear the screen to try to exit the sign on transaction
            cics_error_msg.Text = "Sign on attempt failure"
            exit_CESN
            rc = 1
        Else
            j = 1
            ' Check all the fields for a success or complete message
            For i = 1 To screen.FieldCount
                Set fld = screen.FieldByIndex(i)
                strFld = fld.Text
            
                ' check for the word success in the field
                strsrch = "SUCCESS"
                lngrc = InStr(1, strFld, strsrch, vbTextCompare)
                ' check for the word complete in the field
                strsrch = "complete"
                lngrc2 = InStr(1, strFld, strsrch, vbTextCompare)
                If lngrc > 0 Or lngrc2 > 0 Then
                    ' remember we found it
                    j = 0
                End If
            Next i
            
            If j = 1 Then
                ' It doesn't appear to have worked
                ' clear the screen to try to exit the sign on transaction
                cics_error_msg.Text = "Sign on attempt seems to have failed"
                exit_CESN
                rc = 1
            End If
        End If
    Else
        cics_error_msg.Text = "Unable to run sign on transaction - return code "
        exit_CESN
        rc = 1
    End If
    
    ' update the debug form
    Debugfrm.update_data terminal
    
    Set fld = Nothing
    Set screen = Nothing
    run_signon = rc
End Function

' This subroutine will try to find the first two fields on the first CESN screen
' These fields are assumed to be the user id and password
' This technique is used to try and be somewhat independent of any particular
' CICS release or platform implementation of the CICS sign on transaction (CESN)
Sub findfields()
    Dim i As Integer
    Dim fld As CclField
    
    For i = 1 To screen.FieldCount
        Set fld = terminal.screen.FieldByIndex(i)
        If fld.InputProt = cclUnprotect Then
            If CESNUSER = 0 Then
                CESNUSER = i
            Else
                If CESNPW = 0 Then
                    CESNPW = i
                End If
            End If
        End If
    Next i
End Sub

' Subroutine to try and exit from the CESN transaction
' This routine is called if CESN appears to have not
' worked, to try and return to a clear screen
' This routine will first send a PF3, followed by a
' Clear key
Sub exit_CESN()
    screen.SetAID cclPF3
    terminal.Send Session
    screen.SetAID cclClear
    terminal.Send Session
End Sub
